# Poco::Net

# class HTTPSStreamFactory

Library: NetSSL_OpenSSL
Package: HTTPSClient
Header: Poco/Net/HTTPSStreamFactory.h

## Description

An implementation of the URIStreamFactory interface that handles secure Hyper-Text Transfer Protocol (https) URIs.

## Inheritance

Direct Base Classes: Poco::URIStreamFactory

All Base Classes: Poco::URIStreamFactory

## Member Summary

Member Functions: open, registerFactory, unregisterFactory

Inherited Functions: open

## Constructors

### HTTPSStreamFactory

HTTPSStreamFactory();

Creates the HTTPSStreamFactory.

### HTTPSStreamFactory

HTTPSStreamFactory(
const std::string & proxyHost,
Poco::UInt16 proxyPort = HTTPSession::HTTP_PORT
);

Creates the HTTPSStreamFactory.

HTTPS connections will use the given proxy.

### HTTPSStreamFactory

HTTPSStreamFactory(
const std::string & proxyHost,
Poco::UInt16 proxyPort,
const std::string & proxyUsername,
const std::string & proxyPassword
);

Creates the HTTPSStreamFactory.

HTTPS connections will use the given proxy and will be authorized against the proxy using Basic authentication with the given proxyUsername and proxyPassword.

## Destructor

### ~HTTPSStreamFactory

~HTTPSStreamFactory();

Destroys the HTTPSStreamFactory.

## Member Functions

### open

std::istream * open(
const Poco::URI & uri
);

Creates and opens a HTTPS stream for the given URI. The URI must be a https://... URI.

Throws a NetException if anything goes wrong.

### registerFactory

static void registerFactory();

Registers the HTTPSStreamFactory with the default URIStreamOpener instance.

### unregisterFactory

static void unregisterFactory();

Unregisters the HTTPSStreamFactory with the default URIStreamOpener instance.